﻿SLASH_DSR1 = '/dsr';
SLASH_DSR2 = '/spellreflect';

function string:split(sep)
    local sep, fields = sep or ":", {}
    local pattern = string.format("([^%s]+)", sep)
    self:gsub(pattern, function(c) fields[#fields+1] = c end)
    return fields
end

if not FrameEventosDSR then
    FrameEventosDSR = CreateFrame("Frame", "DSRFrameEventos");
end

local frame = FrameEventosDSR;
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
frame:RegisterEvent("ADDON_LOADED"); 


local function manipulaEvento(self, event, ...)

    if event == "ADDON_LOADED" then
        local prefix, message, channel, sender = select(1, ...);
        if prefix == "Darkbreaker_Spell_Reflect" then
            -- Carrega variaveis salvas
            if ANUNCIAR == nil then
                ANUNCIAR = false;
            end
        end
    elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then

        -- PARAMETROS: timeStamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, missType, isOffHand, amountMissed
        local _, subEvent, _, _, sourceName, _, _, _, destName, _, _, spellId, _, _, missType, _, _ = select(1, ...);

        if (subEvent == "SPELL_MISSED") then
            if (missType == "REFLECT") then
                local mensagem = sourceName.."'s "..GetSpellLink(spellId).." was reflected from "..destName; 

                if ANUNCIAR then
                    SendChatMessage(mensagem, "SAY");
                else
                    print("|cfff58cbaDSR:|r"..mensagem);  
                end
            end
        end
        
   	else
		--print("DSR: "..event)
	end
end

frame:SetScript("OnEvent", manipulaEvento);

function SlashCmdList.DSR(msg, editbox)
    local args = string.split(msg, " ");
    local comando = args[1];

    if comando == "on" then 
        ANUNCIAR = true;
        print("|cfff58cbaDSR:|r spell reflect announces are now |cff00ff00ON|r.");      
    elseif comando == "off" then
        ANUNCIAR = false;
        print("|cfff58cbaDSR:|r spell reflect announces are now |cffff0000OFF|r.");      
    else
        if ANUNCIAR then
            print("|cfff58cbaDSR:|r spell reflect announces are |cff00ff00ON|r.");   
        else
            print("|cfff58cbaDSR:|r spell reflect announces are |cffff0000OFF|r.");  
        end

        -- Se nao for nenhum dos comandos acima, mostrar erro
        DEFAULT_CHAT_FRAME:AddMessage("Syntax: /dsr (on|off...) ",1,1,1);
    end
end

